(*Ŀ
  Source                                                                  
                                                                  
                   by Paul H. Kahler   Jan 1994                             
                   email:  phkahler@oakland.edu                             
                                                                            
                          Traduit et amlior par :                         
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
                   rotates/pans/scales a 256x256 bitmap                     
Ĵ
  Fichier ncessaire                                                      
                                                      
                                                                            
 Une image au format PCX v5.0 compresse en 256x256 pixels et 256 couleurs. 
 L'image '256x256' est utilise par dfaut. Vous pouvez la changer dans les 
 constantes.                                                                
*)

{$M 2048, 0,100000}

{-$DEFINE Fps}      { Affiche le nombre d'images/seconde (fps) }

Uses Clavier,EcranVGA,PCX {$IFDEF Fps} ,Fps {$ENDIF};

CONST
  NOMIMAGE = '256x256.pcx';

Var
  SinTable,CosTable,
  Sin2Table,Cos2Table: Array[0..255] of integer;
  TmpPtr: pointer;
  TextSeg : word; { used as a pointer to the bitmap }

  rot,dr:word;
  x,y,dist,dd:word;
  i: byte;

Procedure PreCalcul; var angle:real; begin
  For i := 0 to 255 do begin   { use 256 degrees in circle }
    angle := i*PI/128;
    SinTable [i] := Round( Sin(angle)*256 );
    CosTable [i] := Round( Cos(angle)*256 );
    Sin2Table[i] := Round( Sin(angle+PI/2)*256*1.2 );
    Cos2Table[i] := Round( Cos(angle+PI/2)*256*1.2 );
  end;                   { the 1.2 accounts for pixel aspect ratio }
end;

Procedure DrawScreen(x,y,scale:word; rot:byte);
var i,j:word;
    ddx,ddy,d2x,d2y : integer;
begin
{ the following 8 lines of code calculate a 'right' and 'down' vector used
  for scanning the source bitmap. I use quotes because these directions
  depend on the rotation. For example, with a rotation, 'right' could mean
  up and to the left while 'down' means up and to the right. Since the
  destination image (screen) is scanned left-right/top-bottom, the bitmap
  needs to be scanned in arbitrary directions to get a rotation. }

  ddx := CosTable[rot]*Scale shr 8; { shr 8 = div 256 }
  ddy := SinTable[rot]*Scale shr 8;

{ Different tables are used for the 'down' vector to account for the non-
  square pixels in mode 13h (320x200). The 90 degree difference is built
  into the tables. If you don't like that, then use (rot+64)and255 here
  and take the pi/2 out of CreateTables. To each his own I guess. }

  d2x := Cos2Table[rot]*SCALE shr 8;
  d2y := Sin2Table[rot]*SCALE shr 8;

{ Since we want to rotate around the CENTER of the screen and not the upper
  left corner, we need to move 160 pixels 'left' and 100 'up' in the bitmap.}

  {i:=x-ddx*160-d2x*100;}
  i := x -(ddx shl 7 + ddx shl 5) -(d2x shl 6+d2x shl 5 +d2x shl 3);
  {j:=y-ddy*160-d2y*100;}
  j := y -(ddy shl 7 + ddy shl 5) -(d2y shl 6+d2y shl 5 +d2y shl 3);

{ The following chunk of assembly does the good stuff. It redraws the entire
  screen by scanning left-right/top-bottom on screen while also scanning the
  bitmap in the arbitrary directions determined above. }

  asm
    push ds

    mov ax,[TextSeg]
    mov ds,ax           { DS:[BX] -> Pointe sur la texture (256x256) }

    mov ax,0A000h
    mov es,ax
    xor di,di           { ES:[DI] -> Pointe sur la mmoire vido (VRAM) }

    mov ax,[ddx]        { this is just to speed things up later }
    mov si,ax           { add ax,si  faster than  add ax,[ddx]  }

    mov cx,200          { Number of rows on Screen }
  @vloop:
    push cx
    mov ax,[i]          { start scanning the source bitmap }
    mov dx,[j]          { at i,j which were calculated above. }
    mov cx,320          { Number of coulumns on screen }
  @hloop:
    add ax,si           { add the 'right' vector to the current }
    add dx,[ddy]        { bitmap coordinates.  8.8 fixed point }
    mov bl,ah           { bx = 256*int(y)+int(x) }
    mov bh,dh
    mov bl,[ds:bx]      { load a pixel from source }
    mov es:[di],bl      { copy it to destination }
    inc di              { advance to next destination pixel }

  (*
  by repeating the above 7 instructions 5 times, and reducing
  the loop count to 64, I have hit 37fps on a 486-33 with a
  fast video card.

  Sur PII233 64Mo avec une Ati Xpert@Work 4Mo AGP -> 138/147 fps (sans VSync)
  *)

    loop @hloop         { End of horizontal loop }

    mov ax,d2x          { get the 'down' vector }
    mov dx,d2y

{    add  si,2          {** uncomment this instr. for extra fun **}

    add i,ax            { i,j is the starting coords for a line }
    add j,dx            { so this moves down one line }
    pop cx              { get the row count back and loop }
    loop @vloop         { End of verticle loop }

    pop ds              { Restore the ds }
  end;
end;

Begin
  { Alloue le tampon }
  if MemAvail < 65536 then begin
    ModeTxt;
    Writeln ('Pas assez de mmoire libre pour cre un tampon d''cran !');
    Writeln ('(manque ',65536 - MemAvail,' octets)');
    Halt (8);
  end;
  GetMem (TmpPtr,$FFFF); TextSeg := Seg(TmpPtr^);

  PreCalcul;
  ModeVga256;

  ChargePCX (Ptr(TextSeg,0),NomImage);

  {$IFDEF Fps} InitFps (319-14*8,191,10,TRUE); {$ENDIF}

  x := 32768; y:=0;           { this corresponds to (128,0) in fixed point }
  rot := 0; dr := 1;          { rotation angle and it's delta }
  dist := 1200; dd := 65534;  { distance to bitmap (sort of) and its delta }
  repeat
    {$IFNDEF Fps} AttendEcran; {$ENDIF}
    DrawScreen(x,y,dist,lo(rot));
    {$IFDEF Fps} ActuFps; {$ENDIF}

    rot := rot+dr;
    inc (y,128);        { slow panning. 1/2 pixel per frame }
    inc (dist,dd);
    if (dist=2000) or (dist=2) then dd := -dd;
    if random(150)=1 then dr := random(7)-3;
  until TouchPresse;

  ModeTxt;
  FreeMem (TmpPtr,$FFFF);
  {$IFDEF Fps} FinFps; {$ENDIF}
end.